---
title: Design & animate your own monster
level: Level 4
language: en-GB
stylesheet: scratch
embeds: "*.png"
materials: "*.sb2"
...

# Introduction: {.intro}

In this project you will design and animate your very own monster! There are a few steps before your monster is finished though. You’ll need to plan what your monster looks like, how they move, where they live and if they make any sounds.

# **Step 1:** Designing your monster {.activity}

**What does your monster look like?** First, try sketching out some monster designs on some blank paper.

+ Think about what limbs it will have, how it will move?
+ What sounds does it make? Can it talk?
+ What kind of environment does it live in?

To give you some ideas, read through step 5. Animating your Monster.

This should take you a whole club session so no need to rush. Ask for more blank paper if you need it!

# **Step 2:** Splitting your monster up into parts {.activity}

When you’re happy with the design, split your monster up into what will be individual sprites, such as arms, legs, head etc. Having your monster made up of separate sprites will give you better control over animation, and allow it to do several things at once.

Draw the parts on a piece of paper and label them.

# **Step 3:** Painting your monster parts in Scratch {.activity}

Once your monster is designed and broken down into parts, it’s time to create it on the computer. You can either do this in Scratch’s sprite editor, or in some photo editing software such as MS Paint or Photoshop. If you’re creating it outside of Scratch, you will need to save your images and import them into Scratch as sprites (you might need to ask for help when doing this).

When importing the sprites into Scratch, be sure to set the centre point on each to be the point at which it will join on to another. e.g. for an arm that will attach to the main body, set the center point to be the shoulder, whereas for a wheel it would be the centre of the hub.

# **Step 4:** Give your monster somewhere to live {.activity}

Finally, create the world your monster lives in by drawing/importing a new background into the stage. Sketch the background on some paper.

# **Step 5:** Animating your monster {.activity}

Your Code Club leader will have sets of cards to help you do this. There are cards for all kinds of body parts and actions. Put them together to make your monster.

Have a look at these cards:

* Legs
* Jointed arm Wheels
* Tentacles
* Eyes
* Mouths and talking Movement

## **Step 6:** More challenges {.challenge}

Finished all that already? Wow! Try having a go at the ideas below.

+ What else does your monster do?
+ What does your monster eat?
+ Can your monster dance?
+ Does your monster have friends?

## Save your work {.save}

Remember to keep saving your work so you can show your friends and family later!
